Name Player_ForwardAttack

CONST
END	//Const

//70-szkenner
//71-ecm
//72-eccm
//73-shield
//74-cloaking
////////// Global command events ///////////////
RULE	event CommandInit
	:action
		Cmd_Beh:=commandBehaviour;
		Main_Target:=commandTarget;		// az egyseg, amit tamadnia kell
		Own_Ship:=this; 				//Store own ship
		Fire_Mode:=1;
		Form_Mode:=3;

		tClearMove();
		tClearFire();
		tClearTerritory();
		O.this:tMoveTo(O.Main_Target, 4, 0);
		O.this:ForceOrient(O.Own_Ship, O.Main_Target, 5);
		
	:end
END

RULE	event ClearCommand
	:action
		O:tClearFollow();
		O:tClearFormation();
		tClearMove();
		tClearFire();
		tClearTerritory();
		tPlayerControl(1);
	:end
END

#include "multifire.mach"

MACHINE "AI"

	STATE battle
	
		RULE	event In
				:action
					SelectShips(20, s.race=@race1);
					if(AllNumOf(20)>0, team1_leader:=Pick(20), ChangeState(noTeam1,0));
					
					ExecList(20, 
						MakeFullyKnown(s.this);
						FreezeReconState(s.this, @race0, 1);
					);
					
					SelectShips(10, s.race=@race0);
					ExecList(10, 
						MakeFullyKnown(s.this);
						FreezeReconState(s.this, @race1, 1);
					);
					m.mainTarget:=Pick(10);
					
					Delay(0,2,LocalEvent(GetTarget),0);
				:end
		END
		
		RULE	event GetTarget
				condition isValid(team1_leader)&isValid(m.mainTarget)
				:action
					SelectShips(10, s.race=@race0);
					if(AllNumOf(10)>0, m.mainTarget:=PickMax(10, 1 / distance(s.this, team1_leader)), ChangeState(noTeam0,0));
					
					LocalEvent(FireTo);
				:end
		END
		
		RULE	event FireTo
				:action
					if(isValid(team1_leader)&isValid(m.mainTarget),
						SelectShips(20, s.race=@race1);
						ExecList(20,
							s.this:tClearFire;
							s.this:tMoveTo(m.mainTarget,2,0);
							s.this:tFireTo(m.maintarget,2);
						),
						//else
						LocalEvent(FatalDamaged, E.ship=team1_leader)
					);
				:end
		END
		
		RULE	event FatalDamaged
				condition E.ship=team1_leader;
				:action
					SelectShips(20, s.race=@race1);
					if(AllNumOf(20)>0, team1_leader:=Pick(20), ChangeState(noTeam1,0));
					
					LocalEvent(GetTarget);
				:end
		END
		
		RULE	event FatalDamaged
				condition E.ship=m.mainTarget;
				:action
					SelectShips(10, s.race=@race0);
					if(AllNumOf(10)>0, m.mainTarget:=Pick(10), ChangeState(noTeam0,0));
					
					LocalEvent(GetTarget);
				:end
		END
	
	END //STATE battle
	
	STATE noTeam1
	
		RULE	event In
				:action
				:end
		END
		
	END //STATE noTeam1
	
	STATE noTeam0
	
		RULE	event In
				:action
				:end
		END
		
	END //STATE noTeam1
	
END //STATE "AI"

////////// State machine command ///////////////
MACHINE "Command"

	///////  CancelTask  ////////////////////////////////////
	//STATE	CancelTask
	
	//	RULE 	event In	
	//		:action
	//			O:tClearCommand();
	//		:end
	//	END
	//	
	//END	//STATE CancelTask

	///////  Aggressive  ///////////////////////////////////
	STATE Aggressive

		RULE 	event In 	
			:action
				If(O.Main_Target,
					O:tClearForbid(0);
					O:tSetForbid(#FORBID_MOTION_MOTIVATION);				//Osszes sajat mozgas tiltasa
					O:tSetForbid(#FORBID_FIRE_BOMBER);						//csak bomberkuldes tiltva, minden mas tuzeles engedelyezve				
					LocalEvent(SelDev, 0);												

					EnableFortPass(O.Own_Ship, 1);							//fortshielden thaladhat
					If(alca, ActivateDevice(alca, 0)); 

					Move_Range:=2;
					Move_Type:=0;

					LocalEvent(Tick, 0);
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END

		RULE 	event Tick
			:action
				If(O.Main_Target,
					LocalEvent(Approach, 0);
					SelectShips(10, S.race!=O.Own_Ship:race & GetRelation(O.Own_Ship:race, S.race)=2 & GetDetected(S.this, O.Own_Ship:race) & Range(S.this, O.Own_Ship)<=3);	// minden artillerynel kozelebb levo detektalt ellenseges hajo levalogatasa
					LocalEvent(DevTurnOn, E.dev:=szenzor);
					If(NumOf(10), 
						LocalEvent(DevTurnOn, E.dev:=ecm);
						LocalEvent(DevTurnOn, E.dev:=eccm);
					, 
						If(ecm, ActivateDevice(ecm, 0));
						If(eccm, ActivateDevice(eccm, 0));
					);
					If(O.Main_Target & Range(O.Main_Target, O.Own_Ship)=2,	O:tEngineMode(0),	O:tEngineMode(1));
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END
		Tick 5.5
		
		#include "Player_X_Rules.inc"

	END	//STATE Aggressive

	///////  Defensive  ///////////////////////////////////
	STATE Defensive

		RULE 	event In 	
			:action
				If(O.Main_Target,
					O:tClearForbid(0);
					O:tSetForbid(#FORBID_MOTION_MOTIVATION);				//Osszes sajat mozgas tiltasa
					O:tSetForbid(#FORBID_FIRE_BOMBER);						//csak bomberkuldes tiltva, minden mas tuzeles engedelyezve				
					O:tSetForbid(#FORBID_FIRE_NOTSHOTBY);					//csak vdekez tzels
					O:tSetForbid(#FORBID_SHIELD);
					LocalEvent(SelDev, 0);								

					If(alca, ActivateDevice(alca, 0)); 
					If(eccm, ActivateDevice(eccm, 0)); 

					Move_Range:=2;
					Move_Type:=0;
					O:tEngineMode(2);

					LocalEvent(Tick, 0);
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END

		RULE 	event Tick
			:action
				If(O.Main_Target,
					If(O.Own_Ship:fort, 
						EnableFortPass(O.Own_Ship, 0);							//fortshielden nem haladhat t
					,
						EnableFortPass(O.Own_Ship, 1);							//fortshielden thaladhat
					);
					LocalEvent(Approach, 0);
					SelectShips(10, S.race!=O.Own_Ship:race & GetRelation(O.Own_Ship:race, S.race)=2 & GetDetected(S.this, O.Own_Ship:race) & Range(S.this, O.Own_Ship)<=3);	// minden artillerynel kozelebb levo detektalt ellenseges hajo levalogatasa
					SelectShips(20, S.race!=O.Own_Ship:race & GetRelation(O.Own_Ship:race, S.race)=2 & GetDetected(S.this, O.Own_Ship:race) & GetDetected(O.Own_Ship, S.race) & Range(S.this, O.Own_Ship)<=3);	// minden artillerynel kozelebb levo engem detektalt ellenseges hajo levalogatasa
					SelectShips(15, S.race!=O.Own_Ship:race & (GetRelation(O.Own_Ship:race, S.race)=2 | GetRelation(O.Own_Ship:race, S.race)=3) & GetDetected(S.this, O.Own_Ship:race));		//detektlt ellensges haj van	
					If(NumOf(10), LocalEvent(DevTurnOn, E.dev:=ecm), If(ecm, ActivateDevice(ecm, 0)));				
					If(NumOf(20), LocalEvent(DevTurnOn, E.dev:=szenzor), If(szenzor, ActivateDevice(szenzor, 0)));
					If(NumOf(15), If(pajzs, ActivateDevice(pajzs, 1)));
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END
		Tick 5.5

		#include "Player_X_Rules.inc"

	END	//STATE Defensive

	///////  Stealth  ///////////////////////////////////
	STATE Stealth

		RULE 	event In 	
			:action
				If(O.Main_Target,
					O:tClearForbid(0);
					O:tSetForbid(#FORBID_MOTION_MOTIVATION);				//Osszes sajat mozgas tiltasa
					O:tSetForbid(#FORBID_FIRE);								//lvldzs tiltva				
					O:tSetForbid(#FORBID_SHIELD);				 				//Pajzs letiltsa
					LocalEvent(SelDev, 0);								

					EnableFortPass(O.Own_Ship, 1);							//fortshielden thaladhat
					If(szenzor, ActivateDevice(szenzor, 0));
					If(ecm, ActivateDevice(ecm, 0));
					If(eccm, ActivateDevice(eccm, 0));
					If(pajzs, ActivateDevice(pajzs, 0));
					LocalEvent(DevTurnOn, E.dev:=alca); 
					SelectDevices(77, O.Own_Ship, S.weapon & !InSet(S.this, 20) & !InSet(S.this, 21) & !InSet(S.this, 22) & !InSet(S.this, 25));				//fegyverek kikapcsolsa
					ExecList(77, ActivateDevice(S.this, 0));

					Move_Range:=2;				
					If(NumOf(74), 
						Move_Type:=0;							
					,
						Move_Type:=1;
					);

					O:tEngineMode(3);										

					LocalEvent(Tick, 0);				
				,
					ChangeState(Canceltask, 0);
				);					
			:end
		END

		RULE 	event Tick
			:action	
				If(O.Main_Target,
					LocalEvent(Approach, 0);
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END
		Tick 5.5

		#include "Player_X_Rules.inc"

	END	//STATE Stealth

	///////  NoFire  ///////////////////////////////////
	STATE NoFire

		RULE 	event In 	
			:action
				If(O.Main_Target,
					O:tClearForbid(0);
					O:tSetForbid(#FORBID_MOTION_MOTIVATION);		//Osszes sajat mozgas tiltasa
					O:tSetForbid(#FORBID_FIRE_BOMBER);				//csak bomberkuldes tiltva, minden mas tuzeles engedelyezve				
					O:tSetForbid(#FORBID_FIRE_FREE);					//CO tzels tiltsa
					LocalEvent(SelDev, 0);								

					EnableFortPass(O.Own_Ship, 1);					//fortshielden thaladhat
					If(alca, ActivateDevice(alca, 0)); 
					If(eccm, ActivateDevice(eccm, 0));

					Move_Range:=2;
					Move_Type:=0;
					O:tEngineMode(1);

					LocalEvent(Tick, 0);
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END

		RULE 	event Tick
			:action
				If(O.Main_Target,
					LocalEvent(Approach, 0);
					SelectShips(10, S.race!=O.Own_Ship:race & GetRelation(O.Own_Ship:race, S.race)=2 & GetDetected(S.this, O.Own_Ship:race) & Range(S.this, O.Own_Ship)<=3);	// minden artillerynel kozelebb levo detektalt ellenseges hajo levalogatasa
					LocalEvent(DevTurnOn, E.dev:=szenzor);	
					If(NumOf(10),
						LocalEvent(DevTurnOn, E.dev:=ecm);					
					,
						If(ecm, ActivateDevice(ecm, 0));
					);
				,
					ChangeState(Canceltask, 0);
				);
			:end
		END
		Tick 5.5
		
		#include "Player_X_Rules.inc"

	END	//STATE NoFire
	
END	//MACHINE "Command"
	

////////// Global command events ///////////////

RULE	event CommandInit
	:action
		Cmd_Beh:=commandBehaviour;
		Main_Target:=commandTarget;		// az egyseg, amit tamadnia kell
		Own_Ship:=this; 				//Store own ship
		Fire_Mode:=0;

		tClearMove();
		tClearFire();
		tClearTerritory();

		If(Main_Target,
			ChooseFirst(
				O.Cmd_Beh=1, GetMachine("Command"):ChangeState(Aggressive, 0), 		// aggressziv allapot
				O.Cmd_Beh=2, GetMachine("Command"):ChangeState(Defensive, 0),	 		// defenziv allapot
				O.Cmd_Beh=3, GetMachine("Command"):ChangeState(Stealth, 0),			// menekulo allapot
				O.Cmd_Beh=4, GetMachine("Command"):ChangeState(NoFire, 0)	 			// clirnyos allapot
			);
		,
			tClearCommand();
		);
	:end
END

//RULE	event ClearCommand
//	:action
//		tClearMove();
//		tClearFire();
//		tClearTerritory();
//		O:tPlayerControl(1);
//	:end
//END

